/* Barrier Shaper.  Contact is Chris Ellenor for Aephraim.  Project started
	July 2005.  Hardware by Alan Stummer, most Verilog by Chris.

 Generated by Quartus II Version 5.0 (Build Build 148 04/26/2005)
 Created on Wed Jul 13 15:30:39 2005
*/

//  Module Declaration
module BSblock (Clk, DACf, USB,DACfClk,DACsClk, Dig,Port1,Port2,Port3,
					Port4,Port5,Port6,Port7,Port8,DACsTrigger,DACsAddress, 
					DACsCommand,DACsDataWord,ADCClk,sinLUTdata,sinLUTadd,Sign,
					ArbRampPtr,ArbRamp1,ArbRamp2,Arb1Prog,Arb2Prog,WriteTOP,ArbRamp1next,ArbRamp2next);


	input             	Clk;					   		//  the master 100MHz clock.
	output 				DACfClk;						//  Clock controlling the fast DAC
	inout		[15:0] 	USB;						 	//  bidirectional USB bus.
	output   	[11:0] 	DACf;							//  Fast single 12-bit DAC.

	output reg	[7:0] 	Dig;						   	//  Digital Input
//	assign				DACfClk	= Clk;					//	Use DACsClk <= !DACsClk on posedges to divide down
	output 				DACsClk;						//  Clock controlling the slow DAC
	output reg  		DACsTrigger;
	output reg 	[3:0] 	DACsAddress, DACsCommand;		//  Outputs to Slow DACs
	output		[15:0]  DACsDataWord;
	reg			[15:0]	DACsDWHolder;
	reg			[8:0]	DACsAddHolder;
	assign				DACsClk	= Clk;					//  Clock for slow DACs... datasheet specifies 50 MHz max clock, but 100 MHz seems to work just fine
	input 		[15:0] 	Port1,Port2,Port3,Port4,Port5,Port6,Port7,Port8;  //  Input from Slow ADCs
	output reg			ADCClk;							//  Clock controlling the ADCs - Max on datasheet is 40MHz
	input		[15:0]	sinLUTdata;
	output		[8:0]	sinLUTadd;
	output				Sign;
	reg 		[7:0]	DataOut;						//	Register for data on its way out the USB
	reg			[11:0]	DACSingleOut;
	reg			[8:0]	sinPtr1;
	reg			[0:8]	sinPtr2;
	reg			[7:0]	sinCtr;
	reg			[7:0]	PhaseOffset;
//	reg			[15:0]	PeakVoltage1;
//	reg			[15:0]	PeakVoltage2;
	wire		[15:0]	PeakVoltage;
	reg			[32:0]  HugeCtr;
	reg					NoStop;
	reg					RampToggle;
	output		[8:0]	ArbRampPtr;
	input		[15:0]	ArbRamp1;
	input		[15:0]	ArbRamp2;
	input		[15:0]	ArbRamp1next;
	input		[15:0]	ArbRamp2next;
	reg			[31:0]	ArbRampHold1;
	reg			[31:0]	ArbRampHold2;
	reg			[15:0]	Factor1;
	reg			[15:0]	Factor2;
	output	reg	[15:0]	Arb1Prog;
	output	reg	[15:0]	Arb2Prog;
	output	reg			WriteTOP;
//	real				Interp1;	
//	real				Interp2;
	wire		[31:0]	Voltage;

	assign 	Voltage = sinLUTdata[14:0] * PeakVoltage;
	assign 	USB[7:0] = (USB[15:12] == 4'b0100) ? DataOut : 8'bz;
//	assign	DACsDataWord = ((USB[15:12] == 4'b0011) && (NoStop == 1)) ? sinLUTdata[14:0] : DACsDWHolder;
	assign	DACsDataWord = ((USB[15:12] == 4'b0011) && (NoStop == 1)) ? Voltage[31:16] : DACsDWHolder;
//	assign	DACsDataWord = ((USB[15:12] == 4'b0011) && (NoStop == 1)) ? {({sinLUTdata[14:0],16'b0} / ({((sinCtr > 40) ? Factor2 : Factor1),16'b0} / PeakVoltage))} : DACsDWHolder;
//	assign	DACsDataWord = ((USB[15:12] == 4'b0011) && (NoStop == 1)) ? {((sinLUTdata[14:0] * (sinCtr > 40) ? (ArbRamp2 - ArbRamp2next):(ArbRamp1 - ArbRamp1next) ) / (((sinCtr > 40) ? (Factor2 * (HugeCtr[22:6]+16'b1)) : (Factor1 * (HugeCtr[22:6]+16'b1))) / PeakVoltage))} : DACsDWHolder;
	assign	sinLUTadd = DACsAddHolder;
	assign 	Sign = ((USB[15:12] == 4'b0011) && (NoStop == 1)) ? sinLUTdata[15] : DACsDWHolder[15];
	assign	ArbRampPtr[8:0] = HugeCtr[31:23];
	assign	PeakVoltage = (sinCtr > 40) ? ArbRampHold1[31:16] : ArbRampHold2[31:16];

	always @ (posedge Clk)  begin
		ADCClk = !ADCClk;
		/** Testing Fun USB Stuff **/
		//   Control word is USB[15:8], DataOut is USB[7:0]
		/*	 Control word for now breaks down as:
				15:12		0000
							0001
							0010			->	Output single value to slow DAC
							0011			->	Main TOP output loop
							0100			->	Get ADC values
							0101
							0110
							0111
							1000
							1001			->	Upload TOP parameters
							1010
							1011			
							1100
							1101			->	Upload Arbitrary Ramp
							1110
							1111
*/
							
		case (USB[15:12])
			4'b0010:	begin									//	Output to slow DAC
							DACsTrigger = 1'b1;
							DACsAddress = 4'b0011;
							DACsDWHolder = {USB[11:0],4'b0000};  // For now just write the first 12 bits as the rest of the USB, and the next four just zeroes
						end
/*  Mirco's Brilliant Invention - Control comes from analog port, Controls are:
		1)	0 < V < 0.5		Hold Constant at Max
		2)	0.5 < V < 1		Arbitrary Ramp
		3)	1 < V < 1.5		Constant Voltage with Feedback
		4)	1.5 < V < 2		OFF		
		
Arbitrary Ramp will be taken from the (main, rewritable) lookup table , and linear interpolate between points
I think 10 Hz or so would be a pretty reasonable "access table" rate, i.e. the 23rd bit of the huge counter
(huge counter runs at 50MHz)

		*/
		
			4'b1101:	begin					//  Upload Ramp Waveforms
							case (USB[11:8])	//  Trying to use a Gray code here for sequential input... not sure it's useful in this particular case
								4'b0000:	HugeCtr[31] = USB[7:0];		// 	Get First half of address
								4'b0001:	HugeCtr[30:23] 	= USB[7:0];	//	Get Second half of address
								4'b0011:	Arb1Prog[15:8]	= USB[7:0];	//	Get First half of 'black' data
								4'b0010:	Arb1Prog[7:0] 	= USB[7:0];	//	Get Second half of 'black' data
								4'b0110:	Arb2Prog[15:8] 	= USB[7:0];	//	Get First half of 'silver' data
								4'b0100:	Arb2Prog[7:0] 	= USB[7:0];	//	Get Second half of 'silver' data
								4'b0101:	WriteTOP = 1'b1;	//	Start update
								4'b0111:	WriteTOP = 1'b0;	//	Finish update
							endcase
								
						end
			4'b1001:	begin					//  Upload Parameters for TOP fields
							case (USB[11:8])	//  Trying to use a Gray code here for sequential input... not sure it's useful in this particular case
								4'b0001:	Factor1[15:8] 	= USB[7:0];
								4'b0011:	Factor1[7:0] 	= USB[7:0];
								4'b0010:	Factor2[15:8] 	= USB[7:0];
								4'b0110:	Factor2[7:0] 	= USB[7:0];
								4'b0100:	PhaseOffset[7:0] 	= USB[7:0];
							endcase
								
						end
			4'b0011:	begin						//  Main TOP output sequence
													//  Ctr:  	1 - 40:		Update first channel - output is assigned to Voltage[31:16] in this case, which is a PeakVoltage * sinLUT data, PeakVoltage comes from ArbRampHold 1 or 2 based on Ctr
													//			41 - 80:	Update second channel
							WriteTOP = 1'b0;
							case (sinCtr)			//	sinCtr counts up to 80 and controls the serial loading of the DACs
								8'd1:	begin
											DACsAddress = 4'b0001;
											DACsCommand = 4'b0000;
											DACsAddHolder = sinPtr1;		//	sinPtr1
//											PeakVoltage = PeakVoltage1;
										end
								8'd2:	DACsTrigger = 1'b1;
								8'd15:	DACsTrigger = 1'b0;
								8'd41:	begin
											DACsAddress = 4'b0010;
											DACsCommand = 4'b0010;
											DACsAddHolder = sinPtr2;
//											PeakVoltage = PeakVoltage2;
										end
								8'd44:	DACsTrigger = 1'b1;
								8'd55:	DACsTrigger = 1'b0; 
								8'd80:	begin
											sinPtr1 = sinPtr1 + 9'd1;
											sinPtr2 = (sinPtr1 + PhaseOffset[7:0]) % 9'd230;
											sinCtr = 8'b0;
										end
							endcase
							sinCtr = sinCtr + 8'b1;
							if (sinPtr1 > 9'd230) begin sinPtr1 = 9'd0; sinPtr2 = (sinPtr1 + PhaseOffset[7:0]) % 9'd230; end
							case (Port1[14:13])		//  Get the control word from the analog channel
								2'b00:	begin
											NoStop = 1'b1; 
											Dig[7] = 1'b0;
											HugeCtr = 32'b0;						//  Hold at max
//											PeakVoltage1 = ArbRamp1;				//  NB max should be first point in ramp file
//											PeakVoltage2 = ArbRamp2;
										end
								2'b01:	begin										//  Arbitrary Ramp
											NoStop = 1'b1; 
											Dig[7] = 1'b0;
										 	if (RampToggle == 1'b1) HugeCtr[31:23] = HugeCtr[31:23] + 9'b1;
											if ((ArbRamp1next != 16'b0) && (ArbRamp2 != 16'b0)) begin 
												HugeCtr = HugeCtr + 32'b1;  		// Stall if there's a zero
												ArbRampHold1 = {ArbRamp1,16'b0} - ((ArbRamp1 - ArbRamp1next) * HugeCtr[22:7]);  //  the interval in terms of HugeCtr should be constant, and allowed for by the arb-ramp upload
												ArbRampHold2 = {ArbRamp2,16'b0} - ((ArbRamp2 - ArbRamp2next) * HugeCtr[22:7]);
											end
//											PeakVoltage = ArbRampHold1;			//	RampToggle variable tells it to stall
//											PeakVoltage2 = ArbRampHold2;			//  when it finds a zero and hold the last
											NoStop = 1'b1;							//	voltage, unless it just came from the other
											RampToggle = 1'b0;						//	ramping part, in which case it should get
										end											//  going again
								2'b10:	begin
											NoStop = 1'b1; 
											Dig[7] = 1'b0;
										 	if (RampToggle == 1'b0) HugeCtr[31:23] = HugeCtr[31:23] + 9'b1;  //used to be 32:24
											if ((ArbRamp1next != 16'b0) && (ArbRamp2 != 16'b0)) begin
												HugeCtr = HugeCtr + 32'b1;
												ArbRampHold1 = {ArbRamp1,16'b0} - ((ArbRamp1 - ArbRamp1next) * HugeCtr[22:7]);
												ArbRampHold2 = {ArbRamp2,16'b0} - ((ArbRamp2 - ArbRamp2next) * HugeCtr[22:7]);
											end
//											PeakVoltage = ArbRampHold1;
//											PeakVoltage2 = ArbRampHold2;
											NoStop = 1'b1;
											RampToggle = 1'b1;
										end
								2'b11:	begin
											DACsDWHolder = 16'b0;				//  Get it to output zero - helped by the assign statement at the top
											if (sinPtr1 == 9'd194) begin		//	wait 'till beginning of lookup table - i.e. get the phase to be the same each time - could control the channels separately
												NoStop = 1'b0;					//	Off		used 194 to compensate for phase shift of filters
												Dig[7] = 1'b1;  				//  Bring Dig Channel high - maybe for IGBT
											end
										end
							endcase

						end
						
/*  Memory Programming:

LabView Will produce 6 strings across the USB:
1)  Control 1111 with Address bit loaded
2)  Control 0111 with Address bit loaded
3)  Control 1111 with Address bit loaded
4)  Control 1111 with Data bit loaded
5)  Control 1101 with Data bit loaded
6)  Control 1111 with Data bit loaded  */
					
			4'b0100:	begin						//  Output ADC result
							case (USB[8])
								1'b0: 	begin
											case (USB[11:9])
												3'b000:  		DataOut = Port1[7:0];
												3'b001:  		DataOut = Port2[7:0];
												3'b010:  		DataOut = Port3[7:0];
												3'b011:  		DataOut = Port4[7:0];
												3'b100:  		DataOut = Port5[7:0];
												3'b101:  		DataOut = Port6[7:0];
												3'b110:  		DataOut = Port7[7:0];
												3'b111:  		DataOut = Port8[7:0];
											endcase
										end							
								1'b1: 	begin
											case (USB[11:9])
												3'b000:  		DataOut = Port1[15:8];
												3'b001:  		DataOut = Port2[15:8];
												3'b010:  		DataOut = Port3[15:8];
												3'b011:  		DataOut = Port4[15:8];
												3'b100:  		DataOut = Port5[15:8];
												3'b101:  		DataOut = Port6[15:8];
												3'b110:  		DataOut = Port7[15:8];
												3'b111:  		DataOut = Port8[15:8];
											endcase
										end							
							endcase
						end
			default: 	begin DACsTrigger = 1'b0; end

		endcase
	end
endmodule
